debug = (require "debug")("json.types")


Maybe  = (arg) ->
  @type = arg
  return

Maybe::toString = ->
  return "Maybe #{@type}"

Either = (args) ->
  @types = args
  return
Either::toString = ->
  return "Either #{@types.join ", "}"

types =
  String:  Symbol "string"
  Number:  Symbol "number"
  Boolean: Symbol "boolean"
  Any:     Symbol "any"
  Maybe:  (arg) ->
    new Maybe arg
  Either: (args) ->
    new Either args


check_schema = (schema, obj) ->
  debug "checking schema #{JSON.stringify schema}"
  switch schema
    when types.String
      typeof obj is 'string'
    when types.Number
      typeof obj is 'number'
    when types.Boolean
      typeof obj is 'boolean'
    when types.Any
      obj?
    else switch
      when schema instanceof Maybe
        if obj?
          check_schema schema.type
        else
          true
      when schema instanceof Either
        schema
          .types
          .some (schema) ->
            check_schema schema, obj
      when (Array.isArray schema)
        (Array.isArray obj) and (obj
          .every (val) ->
            check_schema schema[0], val)
      when typeof schema is 'object'
        Object
          .getOwnPropertyNames schema
          .every (name) ->
            obj[name]? and check_schema schema[name], obj[name]
      else
        false


module.exports =
  types: types
  check_schema: check_schema
